import nspell from "nspell";
import { BuiltInDictionary, Dictionary } from "./types";
declare class NameSpellChecker {
    static get defaultDictionaries(): Readonly<{
        frontEnd: BuiltInDictionary.frontEnd;
    }>;
    constructor(dictionaries?: Array<Dictionary | BuiltInDictionary>);
    nspellInstance: nspell;
    dictionaries: Array<Dictionary>;
    innerDictionaries: Dictionary[];
    innerNameMap: Map<string, string[]>;
    suggest(str: string): string[];
    correct(str: string): boolean;
    add(brandName: string): NameSpellChecker;
    remove(brandName: string): NameSpellChecker;
    dictionary(dic: string): NameSpellChecker;
    personal(personalDic: string): NameSpellChecker;
}
export default NameSpellChecker;
