var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import getInnerName from "./getInnerName";
import similarity from "./similarity";
export default (function (context, str) {
    var names = __spreadArray([], __read(context.innerNameMap.keys()), false);
    var pstr = getInnerName(str);
    var substringSuggests = names.filter(function (name) {
        for (var i = 0; i < name.length; i++) {
            if (name.length > pstr.length) {
                if (name.substring(i).startsWith(pstr)) {
                    return true;
                }
            }
            else {
                if (pstr.substring(i).startsWith(name)) {
                    return true;
                }
            }
            return false;
        }
        return false;
    });
    var nspellSuggests = context.nspellInstance.suggest(pstr);
    var suggests = __spreadArray([], __read(new Set(substringSuggests.concat(nspellSuggests))), false);
    return suggests
        .reduce(function (prev, cur) {
        prev = prev.concat(context.innerNameMap.get(cur) || []);
        return prev;
    }, [])
        .map(function (d) { return [similarity(pstr, d), d]; })
        .sort(function (a, b) { return b[0] - a[0]; })
        .map(function (d) { return d[1]; });
});
